#include <stdlib.h>
#include "PCD8544.h"

#define NUM_LIVES 5;

#define bool unsigned char
#define false 0
#define true 1

#define ENEMY_ROWS 5
#define ENEMIES_PER_ROW 10
#define SPACE_SIZE 3

#define ENEMY_SIZE_X 6
#define ENEMY_SIZE_Y 2


char enemy_model_spiky[2][6] = {
	"......",
	". .. ."
};

char enemy_model_pointy[2][6] = {
	"......",
	" .... "};

char enemy_model_flat[2][6] = {
	"..  ..",
	"......"
};

char player_model[2][6] = {
	"  ..  ",
	"......"
};

typedef enum
{
	spiky,
	pointy,
	flat,
	hero
} type;

struct enemy {
	unsigned char pos_x;
	unsigned char pos_y;
	type shape;
	bool alive;
};

bool game_over = false;
bool game_won = false;

int lives;

struct enemy enemy_list[ENEMY_ROWS * ENEMIES_PER_ROW];
struct enemy player;

void init_game()
{
	int i, j;

	lives = NUM_LIVES;
	player.pos_x = LCD_X_RES / 2 - ENEMY_SIZE_X / 2;
	player.pos_y = LCD_Y_RES - 5;

	game_over = false;
	game_won = false;
	
	for (i = 0; i < ENEMY_ROWS; ++i) {
		for (j = 0; j < ENEMIES_PER_ROW; ++j) {
			struct enemy escobar;
			escobar.pos_x = (ENEMY_SIZE_X + SPACE_SIZE) * j;
			escobar.pos_y = 5 + (ENEMY_SIZE_Y + SPACE_SIZE) * i;
			escobar.alive = true;
			switch (i) {
			case 1:
			case 4:
				escobar.shape = spiky;
				break;
			case 2:
			case 5:
				escobar.shape = pointy;
				break;
			default:
				escobar.shape = flat;
				break;
			}
			enemy_list[i * ENEMY_ROWS + j] = escobar;
		}
	}
}

typedef enum
{
	UP,
	LEFT,
	SHOOT
} cmd;

void drawEnemy(int x, int y, int mode, char model[2][6])
{
	int i, j;
	for (i = 0; i < 2; i++) {
		for (j = 0; j < 6; j++) {
			if (model[i][j] == '.')
				LcdPixel(x + j, y + i, mode);
		}
	}
}


void Print_game()
{
	int i, j, k;
	for (k = 0; k < ENEMY_ROWS * ENEMIES_PER_ROW; k++) {
		struct enemy en = enemy_list[k];
		switch (en.shape) {
		case spiky:
			drawEnemy(en.pos_x, en.pos_y, PIXEL_ON, enemy_model_spiky);
			break;
		case pointy:
			drawEnemy(en.pos_x, en.pos_y, PIXEL_ON, enemy_model_pointy);
			break;
		case flat:
			drawEnemy(en.pos_x, en.pos_y, PIXEL_ON, enemy_model_flat);
			break;
		}
	}

	for (i = 0; i < 2; i++) {
		for (j = 0; j < 6; j++) {
			if (player_model[i][j] == '.')
				LcdPixel(player.pos_x + j, player.pos_y + i, PIXEL_ON);
		}
	}
}

int main(void)
{
	lives = lives;


	LcdInit();

	LcdClear();
	LcdUpdate();
	
	init_game();

	Print_game();
	LcdUpdate();

	while (lives > 0 && !game_over ) {

		
		
	}


}
